<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "ads_tracking".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "AdsTracking".
 *
 * Columns in table "ads_tracking" available as properties of the model,
 * followed by relations of table "ads_tracking" available as properties of the model.
 *
 * @property integer $id
 * @property integer $partner_id
 * @property integer $waiting_room_invite_id
 * @property integer $provider_id
 * @property string $provider_specialty
 * @property string $visit_reason
 * @property string $date_added
 * @property string $confirm
 *
 * @property Provider $provider
 * @property WaitingRoomInvite $waitingRoomInvite
 */
abstract class BaseAdsTracking extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'ads_tracking';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'AdsTracking|AdsTrackings', $n);
    }

    public static function representingColumn()
    {
        return 'provider_specialty';
    }

    public function rules()
    {
        return array(
            array('partner_id, provider_id, provider_specialty, visit_reason, date_added', 'required'),
            array('partner_id, waiting_room_invite_id, provider_id', 'numerical', 'integerOnly'=>true),
            array('provider_specialty', 'length', 'max'=>250),
            array('visit_reason, confirm', 'length', 'max'=>50),
            array('waiting_room_invite_id, confirm', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, partner_id, waiting_room_invite_id, provider_id, provider_specialty, visit_reason, date_added, confirm', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'waitingRoomInvite' => array(self::BELONGS_TO, 'WaitingRoomInvite', 'waiting_room_invite_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'partner_id' => Yii::t('app', 'Partner'),
            'waiting_room_invite_id' => null,
            'provider_id' => null,
            'provider_specialty' => Yii::t('app', 'Provider Specialty'),
            'visit_reason' => Yii::t('app', 'Visit Reason'),
            'date_added' => Yii::t('app', 'Date Added'),
            'confirm' => Yii::t('app', 'Confirm'),
            'provider' => null,
            'waitingRoomInvite' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('partner_id', $this->partner_id);
        $criteria->compare('waiting_room_invite_id', $this->waiting_room_invite_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('provider_specialty', $this->provider_specialty, true);
        $criteria->compare('visit_reason', $this->visit_reason, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('confirm', $this->confirm, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
